## oem-tangshan-rubikpi3-thermal 1.1.0ubuntu0

=== Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
# Makefile for rubikpi3-thermal
PKG_NAME := oem-tangshan-rubikpi3-thermal
VERSION := 1.1.0
DEB_VERSION := $(VERSION)-1

DESTDIR ?=
PREFIX ?= /usr
BINDIR := $(DESTDIR)$(PREFIX)/bin
INCLUDE_DIR := $(DESTDIR)$(PREFIX)/include
LIB_DIR := $(DESTDIR)$(PREFIX)/lib

BUILD_DIR := build
DEB_BUILD_DIR := $(BUILD_DIR)/deb
PKG_BUILD_DIR := $(DEB_BUILD_DIR)/$(PKG_NAME)

SUBDIRS = src
LIBDIRS = tools/thermal/lib tools/lib/thermal
TOOL_BUILD_DIRS = tools/build/

srctree := $(shell pwd)

.PHONY: install clean deb source binary $(SUBDIRS) $(LIBDIRS)

all: $(SUBDIRS)

install: $(LIBDIRS)
	@mkdir -p $(BINDIR)
	@mkdir -p $(INCLUDE_DIR)

	$(MAKE) -C $< install
	$(MAKE) -C $(SUBDIRS) install INSTALL_DIR=$(BINDIR) srctree=$(srctree)

$(SUBDIRS): lib
	$(MAKE) -C $@ srctree=$(srctree)

build: all

deb:
	@fakeroot dh binary

source:
	@tar -cJf ../$(PKG_NAME)_$(VERSION).orig.tar.xz --exclude=debian ./

binary: deb

lib: $(LIBDIRS)
$(LIBDIRS):
	$(MAKE) -C $@

clean:
	for dir in $(SUBDIRS); do $(MAKE) -C $$dir clean; done
	for dir in $(LIBDIRS); do $(MAKE) -C $$dir clean; done
	for dir in $(TOOL_BUILD_DIRS); do $(MAKE) -C $$dir clean; done
	dh_clean

=== src/Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)

export CC V DESTDIR

DESTDIR?=/

ifneq ($V,1)
Q ?= @
endif

CC		= $(CROSS_COMPILE)gcc
LD		= $(CROSS_COMPILE)ld
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
READELF		= $(CROSS_COMPILE)readelf
STRIP		= $(CROSS_COMPILE)strip

INCLUDE	= -I$(srctree)/tools/lib/thermal/include -I$(srctree)/tools/thermal/lib -I/usr/include/libnl3
CFLAGS	= $(DEBUG) -Wall -Wextra $(INCLUDE) -Winline -pipe $(EXTRA_CFLAGS)
LDFLAGS	= -L$(srctree)/tools/lib/thermal -L$(srctree)/tools/thermal/lib -static
LIBS    = -lthermal -lnl-3 -lnl-genl-3 -lthermal_tools

SRC = rubikpi-thermal.c

OBJ	=	$(SRC:.c=.o)

rubikpi-thermal: $(OBJ)
	$Q $(CC) -o $@ $(OBJ) $(LIBS) $(LDFLAGS) $(INCLUDE)

install:
	$Q install -m 755 $(srctree)/src/rubikpi-thermal $(INSTALL_DIR)


.PHONY: clean
clean:
	rm -f *.o rubikpi-thermal

=== tools/lib/thermal/Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
# Most of this file is copied from tools/lib/perf/Makefile

LIBTHERMAL_VERSION = 0
LIBTHERMAL_PATCHLEVEL = 0
LIBTHERMAL_EXTRAVERSION = 1

MAKEFLAGS += --no-print-directory

ifeq ($(srctree),)
srctree := $(patsubst %/,%,$(dir $(CURDIR)))
srctree := $(patsubst %/,%,$(dir $(srctree)))
srctree := $(patsubst %/,%,$(dir $(srctree)))
# $(info Determined 'srctree' to be $(srctree))
endif

INSTALL = install

# Use DESTDIR for installing into a different root directory.
# This is useful for building a package. The program will be
# installed in this directory as if it was the root directory.
# Then the build tool can move it later.
DESTDIR ?=
DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'

include $(srctree)/tools/scripts/Makefile.include
include $(srctree)/tools/scripts/Makefile.arch

libdir_relative = usr/lib

prefix ?=
libdir = $(prefix)/$(libdir_relative)

# Shell quotes
libdir_SQ = $(subst ','\'',$(libdir))
libdir_relative_SQ = $(subst ','\'',$(libdir_relative))

ifeq ("$(origin V)", "command line")
  VERBOSE = $(V)
endif
ifndef VERBOSE
  VERBOSE = 0
endif

ifeq ($(VERBOSE),1)
  Q =
else
  Q = @
endif

# Set compile option CFLAGS
ifdef EXTRA_CFLAGS
  CFLAGS := $(EXTRA_CFLAGS)
else
  CFLAGS := -g -Wall
endif

INCLUDES = \
-I/usr/include/libnl3 \
-I$(srctree)/tools/lib/thermal/include \
-I$(srctree)/tools/lib/ \
-I$(srctree)/tools/include \
-I$(srctree)/tools/arch/$(SRCARCH)/include/ \
-I$(srctree)/tools/arch/$(SRCARCH)/include/uapi \
-I$(srctree)/tools/include/uapi

# Append required CFLAGS
override CFLAGS += $(EXTRA_WARNINGS)
override CFLAGS += -Werror -Wall
override CFLAGS += -fPIC
override CFLAGS += $(INCLUDES)
override CFLAGS += -fvisibility=hidden
override CFGLAS += -Wl,-L.
override CFGLAS += -Wl,-lthermal

all:

export srctree OUTPUT CC LD CFLAGS V
export DESTDIR DESTDIR_SQ

include $(srctree)/tools/build/Makefile.include

VERSION_SCRIPT := libthermal.map

PATCHLEVEL    = $(LIBTHERMAL_PATCHLEVEL)
EXTRAVERSION  = $(LIBTHERMAL_EXTRAVERSION)
VERSION       = $(LIBTHERMAL_VERSION).$(LIBTHERMAL_PATCHLEVEL).$(LIBTHERMAL_EXTRAVERSION)

LIBTHERMAL_SO := $(OUTPUT)libthermal.so.$(VERSION)
LIBTHERMAL_A  := $(OUTPUT)libthermal.a
LIBTHERMAL_IN := $(OUTPUT)libthermal-in.o
LIBTHERMAL_PC := $(OUTPUT)libthermal.pc
LIBTHERMAL_ALL := $(LIBTHERMAL_A) $(OUTPUT)libthermal.so*

THERMAL_UAPI := include/uapi/linux/thermal.h

$(THERMAL_UAPI): FORCE
	@mkdir -p $(dir $(srctree)/tools/$@)
	ln -sf $(srctree)/$@ $(srctree)/tools/$@

$(LIBTHERMAL_IN): FORCE
	$(Q)$(MAKE) $(build)=libthermal

$(LIBTHERMAL_A): $(LIBTHERMAL_IN)
	$(QUIET_AR)$(RM) $@ && $(AR) rcs $@ $(LIBTHERMAL_IN)

$(LIBTHERMAL_SO): $(LIBTHERMAL_IN)
	$(QUIET_LINK)$(CC) --shared -Wl,-soname,libthermal.so \
                                    -Wl,--version-script=$(VERSION_SCRIPT) $^ -o $@
	@ln -sf $(@F) $(OUTPUT)libthermal.so
	@ln -sf $(@F) $(OUTPUT)libthermal.so.$(LIBTHERMAL_VERSION)


libs: $(THERMAL_UAPI) $(LIBTHERMAL_A) $(LIBTHERMAL_SO) $(LIBTHERMAL_PC)

all: fixdep
	$(Q)$(MAKE) libs

clean:
	$(call QUIET_CLEAN, libthermal) $(RM) $(LIBTHERMAL_A) \
                *.o *~ *.a *.so *.so.$(VERSION) *.so.$(LIBTHERMAL_VERSION) .*.d .*.cmd LIBTHERMAL-CFLAGS $(LIBTHERMAL_PC)

$(LIBTHERMAL_PC):
	$(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
		-e "s|@LIBDIR@|$(libdir_SQ)|" \
		-e "s|@VERSION@|$(VERSION)|" \
		< libthermal.pc.template > $@

define do_install_mkdir
	if [ ! -d '$(DESTDIR_SQ)$1' ]; then             \
		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1'; \
	fi
endef

define do_install
	if [ ! -d '$(DESTDIR_SQ)$2' ]; then             \
		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2'; \
	fi;                                             \
	$(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR_SQ)$2'
endef

install_lib: libs
	$(call QUIET_INSTALL, $(LIBTHERMAL_ALL)) \
		$(call do_install_mkdir,$(libdir_SQ)); \
		cp -fpR $(LIBTHERMAL_ALL) $(DESTDIR)$(libdir_SQ)

install_headers:
	$(call QUIET_INSTALL, headers) \
		$(call do_install,include/thermal.h,$(prefix)/usr/include/thermal,644); \

install_pkgconfig: $(LIBTHERMAL_PC)
	$(call QUIET_INSTALL, $(LIBTHERMAL_PC)) \
		$(call do_install,$(LIBTHERMAL_PC),$(libdir_SQ)/pkgconfig,644)

install_doc:
	$(Q)$(MAKE) -C Documentation install-man install-html install-examples

install: install_lib install_headers install_pkgconfig

FORCE:

.PHONY: all install clean FORCE

=== tools/thermal/lib/Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
# Most of this file is copied from tools/lib/perf/Makefile

LIBTHERMAL_TOOLS_VERSION = 0
LIBTHERMAL_TOOLS_PATCHLEVEL = 0
LIBTHERMAL_TOOLS_EXTRAVERSION = 1

MAKEFLAGS += --no-print-directory

ifeq ($(srctree),)
srctree := $(patsubst %/,%,$(dir $(CURDIR)))
srctree := $(patsubst %/,%,$(dir $(srctree)))
srctree := $(patsubst %/,%,$(dir $(srctree)))
# $(info Determined 'srctree' to be $(srctree))
endif

INSTALL = install

# Use DESTDIR for installing into a different root directory.
# This is useful for building a package. The program will be
# installed in this directory as if it was the root directory.
# Then the build tool can move it later.
DESTDIR ?=
DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'

include $(srctree)/tools/scripts/Makefile.include
include $(srctree)/tools/scripts/Makefile.arch

libdir_relative = usr/lib

prefix ?=
libdir = $(prefix)/$(libdir_relative)

# Shell quotes
libdir_SQ = $(subst ','\'',$(libdir))
libdir_relative_SQ = $(subst ','\'',$(libdir_relative))

ifeq ("$(origin V)", "command line")
  VERBOSE = $(V)
endif
ifndef VERBOSE
  VERBOSE = 0
endif

ifeq ($(VERBOSE),1)
  Q =
else
  Q = @
endif

# Set compile option CFLAGS
ifdef EXTRA_CFLAGS
  CFLAGS := $(EXTRA_CFLAGS)
else
  CFLAGS := -g -Wall
endif

INCLUDES = \
-I/usr/include/libnl3 \
-I$(srctree)/tools/lib/thermal/include \
-I$(srctree)/tools/lib/ \
-I$(srctree)/tools/include \
-I$(srctree)/tools/arch/$(SRCARCH)/include/ \
-I$(srctree)/tools/arch/$(SRCARCH)/include/uapi \
-I$(srctree)/tools/include/uapi

# Append required CFLAGS
override CFLAGS += $(EXTRA_WARNINGS)
override CFLAGS += -Werror -Wall
override CFLAGS += -fPIC
override CFLAGS += $(INCLUDES)
override CFGLAS += -Wl,-L.
override CFGLAS += -Wl,-lthermal

all:

export srctree OUTPUT CC LD CFLAGS V
export DESTDIR DESTDIR_SQ

include $(srctree)/tools/build/Makefile.include

PATCHLEVEL    = $(LIBTHERMAL_TOOLS_PATCHLEVEL)
EXTRAVERSION  = $(LIBTHERMAL_TOOLS_EXTRAVERSION)
VERSION       = $(LIBTHERMAL_TOOLS_VERSION).$(LIBTHERMAL_TOOLS_PATCHLEVEL).$(LIBTHERMAL_TOOLS_EXTRAVERSION)

LIBTHERMAL_TOOLS_SO := $(OUTPUT)libthermal_tools.so.$(VERSION)
LIBTHERMAL_TOOLS_A  := $(OUTPUT)libthermal_tools.a
LIBTHERMAL_TOOLS_IN := $(OUTPUT)libthermal_tools-in.o
LIBTHERMAL_TOOLS_PC := $(OUTPUT)libthermal_tools.pc

LIBTHERMAL_TOOLS_ALL := $(LIBTHERMAL_TOOLS_A) $(OUTPUT)libthermal_tools.so*

$(LIBTHERMAL_TOOLS_IN): FORCE
	$(Q)$(MAKE) $(build)=libthermal_tools

$(LIBTHERMAL_TOOLS_A): $(LIBTHERMAL_TOOLS_IN)
	$(QUIET_AR)$(RM) $@ && $(AR) rcs $@ $(LIBTHERMAL_TOOLS_IN)

$(LIBTHERMAL_TOOLS_SO): $(LIBTHERMAL_TOOLS_IN)
	$(QUIET_LINK)$(CC) --shared -Wl,-soname,libthermal_tools.so $^ -o $@
	@ln -sf $(@F) $(OUTPUT)libthermal_tools.so
	@ln -sf $(@F) $(OUTPUT)libthermal_tools.so.$(LIBTHERMAL_TOOLS_VERSION)


libs: $(LIBTHERMAL_TOOLS_A) $(LIBTHERMAL_TOOLS_SO) $(LIBTHERMAL_TOOLS_PC)

all: fixdep
	$(Q)$(MAKE) libs

clean:
	$(call QUIET_CLEAN, libthermal_tools) $(RM) $(LIBTHERMAL_TOOLS_A) \
                *.o *~ *.a *.so *.so.$(VERSION) *.so.$(LIBTHERMAL_TOOLS_VERSION) .*.d .*.cmd LIBTHERMAL_TOOLS-CFLAGS $(LIBTHERMAL_TOOLS_PC)

$(LIBTHERMAL_TOOLS_PC):
	$(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
		-e "s|@LIBDIR@|$(libdir_SQ)|" \
		-e "s|@VERSION@|$(VERSION)|" \
		< libthermal_tools.pc.template > $@

define do_install_mkdir
	if [ ! -d '$(DESTDIR_SQ)$1' ]; then             \
		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1'; \
	fi
endef

define do_install
	if [ ! -d '$(DESTDIR_SQ)$2' ]; then             \
		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2'; \
	fi;                                             \
	$(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR_SQ)$2'
endef

install_lib: libs
	$(call QUIET_INSTALL, $(LIBTHERMAL_TOOLS_ALL)) \
		$(call do_install_mkdir,$(libdir_SQ)); \
		cp -fpR $(LIBTHERMAL_TOOLS_ALL) $(DESTDIR)$(libdir_SQ)

install_headers:
	$(call QUIET_INSTALL, headers) \
		$(call do_install,include/thermal.h,$(prefix)/usr/include/thermal,644); \
		$(call do_install,thermal-tools.h,$(prefix)/usr/include/thermal,644); \
		$(call do_install,log.h,$(prefix)/usr/include/thermal,644); \
		$(call do_install,mainloop.h,$(prefix)/usr/include/thermal,644); \
		$(call do_install,uptimeofday.h,$(prefix)/usr/include/thermal,644); \

install_pkgconfig: $(LIBTHERMAL_TOOLS_PC)
	$(call QUIET_INSTALL, $(LIBTHERMAL_TOOLS_PC)) \
		$(call do_install,$(LIBTHERMAL_TOOLS_PC),$(libdir_SQ)/pkgconfig,644)

install_doc:
	$(Q)$(MAKE) -C Documentation install-man install-html install-examples

#install: install_lib install_headers install_pkgconfig install_doc
install: install_lib install_headers install_pkgconfig

FORCE:

.PHONY: all install clean FORCE

=== debian/changelog ===
oem-tangshan-rubikpi3-thermal (1.1.0ubuntu0) noble; urgency=medium

  [ Hongyang ]
  * Initial release.
  * Modified to be triggered by netlink API.

  [ Ethan Hsieh ]
  * Refactored Makefile to follow standard Debian packaging conventions
  * Updated installation paths to use proper PREFIX-based directories
  * Removed systemd service installation from Makefile (now handled by debian packaging)
  * Updated debian/control with proper package metadata and dependencies
  * Added rubikpi3-thermal-dev package for development files
  * Fixed thermal.h symlink creation in tools/lib/thermal/Makefile
  * Added netlink library dependencies (libnl-3-dev, libnl-genl-3-dev)
  * Improved package descriptions with detailed functionality information
  * Renamed package to oem-tangshan-rubikpi3-thermal

 -- Ethan Hsieh <ethan.hsieh@canonical.com>  Sat, 26 Jul 2025 05:55:19 +0000

=== debian/control ===
Source: oem-tangshan-rubikpi3-thermal
Section: utils
Priority: optional
Maintainer: Commercial Engineering <commercial-engineering@canonical.com>
Build-Depends: debhelper-compat (= 13), libnl-3-dev, libnl-genl-3-dev
Standards-Version: 4.6.2
Vcs-Git: https://code.launchpad.net/~tangshan-team/tangshan/+git/rubikpi3_thermal

Package: oem-tangshan-rubikpi3-thermal
Architecture: arm64
Depends: ${misc:Depends}, ${shlibs:Depends}, libnl-3-200, libnl-genl-3-200
Description: Fan Management for RUBIK Pi 3
 This package provides thermal management for the RUBIK Pi 3. It monitors
 system temperature and automatically controls fan speed to maintain
 optimal operating temperatures.
 .
 The daemon runs as a systemd service and uses netlink API to receive
 thermal events from the kernel, providing efficient and responsive
 temperature monitoring and fan control.

Package: oem-tangshan-rubikpi3-thermal-dev
Architecture: arm64
Depends: ${misc:Depends}, oem-tangshan-rubikpi3-thermal (= ${binary:Version}), libnl-3-dev, libnl-genl-3-dev
Description: Development files for RUBIK Pi 3 thermal management
 This package contains the header files, static libraries, and development
 files needed to develop applications that use the thermal management
 libraries for RUBIK Pi 3.
 .
 Install this package if you want to develop programs that interact with
 the thermal management system or build custom thermal control applications.
